namespace MainNamespace.Structure
{
    class Graph<T>
    {
        private List<GraphNode<T>> _nodeList;

        public Graph()
        {
            _nodeList = new List<GraphNode<T>>();
        }

        public GraphNode<T> AddNode(T data)
        {
            GraphNode<T> node = new GraphNode<T>(data);
            _nodeList.Add(node);
            return node;
        }

        public GraphNode<T> AddNode(GraphNode<T> node)
        {
            _nodeList.Add(node);
            return node;
        }

        public void AddEdge(GraphNode<T> from, GraphNode<T> to, bool oneway = true, int weight = 0)
        {
            from.Neighbors.Add(to);
            from.Weights.Add(weight);

            if (!oneway)
            {
                to.Neighbors.Add(from);
                to.Weights.Add(weight);
            }
        }

        internal void DebugPrintLinks()
        {
            foreach (var node in _nodeList)
            {
                for (int i = 0; i < node.Neighbors.Count; i++)
                {
                    var neighbor = node.Neighbors[i];
                    var weight = node.Weights[i];

                    System.Console.WriteLine($"[{node.Data}] ---{weight}--- [{neighbor.Data}]");
                }
            }
        }
    }
}