using treeStructure.BT;

namespace treeStructure.BST
{
    class BST<T>
    {
        private BinaryTreeNode<T> _root = null;
        private Comparer<T> _comparer = Comparer<T>.Default;

        public void Insert(T value)
        {
            BinaryTreeNode<T> node = _root;
            if (node == null)
            {
                _root = new BinaryTreeNode<T>(value);
                return;
            }

            while (node != null)
            {
                int result = _comparer.Compare(node.Data, value);
                if (result == 0)
                    return;

                if (result > 0)
                {
                    if (node.Left == null)
                    {
                        node.Left = new BinaryTreeNode<T>(value);
                        return;
                    }

                    node = node.Left;
                }
                else
                {
                    if (node.Right == null)
                    {
                        node.Right = new BinaryTreeNode<T>(value);
                        return;
                    }

                    node = node.Right;
                }
            }
        }

        public void PreOrderTraversal()
        {
            PreOrderRecursive(_root);
        }

        private void PreOrderRecursive(BinaryTreeNode<T> node)
        {
            if (node == null)
                return;

            System.Console.WriteLine(node.Data);
            PreOrderRecursive(node.Left);
            PreOrderRecursive(node.Right);
        }
    }
}